# ======================================================================================================================
#  fennec, a free and open source game engine
#  Copyright © 2025 - 2026  Medusa Slockbower
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <https://www.gnu.org/licenses/>.
# ======================================================================================================================

import gdb

# CSTRING ==============================================================================================================
class CStringPrinter:
    def __init__(self, val):
        self.val = val

    def display_hint(self):
        return 'string'

    def to_string(self):
        value = "\"" + self.val['_str'].string('', 'replace', self.val['_size']) + "\""
        return value

    def display_hint(self):
        return 'string'


# STRING ===============================================================================================================
class StringPrinter:
    def __init__(self, val):
        self.val = val['_str']

    def to_string(self):
        value = "\"" + self.val['_data'].string('', 'replace', self.val['_capacity'] - 1) + "\""
        return value

    def display_hint(self):
        return 'string'


# GDB Code =============================================================================================================

def register_printers():
    print("registering strings")
    pp = gdb.printing.RegexpCollectionPrettyPrinter("fennec::strings")
    pp.add_printer('fennec::cstring',  '^fennec::cstring$',     CStringPrinter)
    pp.add_printer('fennec::wcstring', '^fennec::wcstring$',    CStringPrinter)
    pp.add_printer('fennec::string',   '^fennec::_string<.*>$',  StringPrinter)
    pp.add_printer('fennec::wstring',  '^fennec::_wstring<.*>$', StringPrinter)
    return pp

printer = register_printers()